﻿using UnityEngine;
using System.Collections;

public class AlphaDissolveTest : MonoBehaviour {

	private Material material = null;
	private int _Width = 0;
	private int _Cutoff = 0;

	// Use this for initialization
	void Start () {
		material = GetComponentInChildren<Renderer>().material;
		_Width = Shader.PropertyToID("_Width");
		_Cutoff = Shader.PropertyToID("_CutOff");

		if (material != null) {
			material.SetFloat (_Cutoff, 1f);
			material.SetFloat (_Width, 1f);			
			StartCoroutine ("ProcDissolve");
		}
	}

	IEnumerator ProcDissolve ()
	{
		float waitTime = 1f;
		yield return new WaitForSeconds(waitTime);

		float cutoffTime = 1f;
		for (float n = 0f; n <= cutoffTime; n += Time.deltaTime) 
		{
			yield return new WaitForSeconds(0.032f); //30fps
			material.SetFloat(_Cutoff, 1 - n/cutoffTime);
		}

		float widthTime = 1f;
		for (float n = 0f; n <= widthTime; n += Time.deltaTime) 
		{
			yield return new WaitForSeconds(0.032f); //30fps
			material.SetFloat(_Width, 1- n/widthTime);
		}
	}

}
